@echo off

rem Feb 2019 by Evariste F5OEO - QO-100 Release 0.9 (Completely rewritten)
rem Started from original tool
rem Idea from Portsdown vmix ffmpeg script

rem ================= MOST OFTEN VARIABLE ==========

rem _______________ MODULATOR SETTING _________________
rem set qrg=1.2e9
set qrg=2.40825e9
set gainrf=0.75
set SR=333
set FECNUM=2
set FECDEN=3
set MODE=DVBS2
set CONSTEL=QPSK
set rpi_command=0
set vmix=1
rem ________________ VIDEO SETTING ______________________
set Codec=x264
rem WARNING ! VideoResolution is changed according to SymbolRate
set VideoResolution=768x576
set aspectratio=4:3
set fps=25

rem _________________ AUDIO SETTING _______________________
set audioenable=1
set /A audiobitrate = 24000
if %audioenable% == 0 (
set audiobitrate = 0
)

rem ================= SETUP ONCE ===========

set callsign=Yourcall
rem Set appropriately
set raspi_ip=192.168.1.43
rem set raspi_ip=230.0.0.10
rem ------------ OUTPUT (NOT TO BE CHANGED UNTIL KNOWING WHAT WE ARE DOING ----------------------
rem set ip=127.0.0.1:10000
set ip=%raspi_ip%:10000
set user=pi
set passwd=raspberry

rem ------------- ENVIRONMENT SETTING -------------------
rem Portsdown default

rem Porstdown setup    
set dvb2iqpath=/home/pi/rpidatv/bin/dvb2iq
set sendiqpath=/home/pi/rpidatv/bin/limesdr_send

echo dvb2iq %dvb2iqpath%
echo sendiqpath %sendiqpath%


rem ================= INTERACTIVE =======================
rem --- SR asked only once ----
cls
echo ==== Enter a new FEC =====
set /p SR="SymbolRate(Ks) (%SR%)"


:PromptMe

echo ==== Enter a new FEC =====
echo SR=%SR%
set /p FECNUM="Fec numerator (%FECNUM%)(q to quit)"
if %FECNUM%==q ( 
GOTO :Quit
)

set /p FECDEN="Fec denominator(%FECDEN%)"
if %FECDEN%==q ( 
GOTO :Quit
)

cls

rem =========== Bitrate calculation ===============
if %MODE% == DVBS2 (
set correc=980
if %CONSTEL% == QPSK (
set Me=2
)
if %CONSTEL% == 8PSK (
set Me=3)
)

if %MODE% == DVBS (
set Me=2
set correc=922
)

set /A Calculatebitrate = %SR% * 100 * %Me% * %FECNUM% * %correc% / ( %FECDEN%* 100)  
echo NetBitrate = %Calculatebitrate% 


set TSBITRATE=%Calculatebitrate%
set /A VIDRATE= (%TSBITRATE% - 50000 - %audiobitrate% * 125 /100) * 80 / 100 
set /A BUFSIZE=%VIDRATE% * 40 / 100  

rem _____________ TEXT HERE _______________________________

set TextConstellation=%MODE%-%CONSTEL% %SR%K FEC %FECNUM%/%FECDEN% %Codec%

rem =============== Decide video resolution =======================
rem ------ X264 --------
if %Codec% == x264 (

if /I %VIDRATE% LEQ 250000 (
set VideoResolution=352x288
)

if /I %VIDRATE% GEQ 700000 (
set VideoResolution=1280x720
)
)

rem ------ X265 --------
if %Codec% == x265 (
if /I %VIDRATE% LEQ 120000 (
set VideoResolution=352x288
)

if /I %VIDRATE% GEQ 400000 (
set VideoResolution=1280x720
)
)

echo VideoBitrate = %VIDRATE% VBV %BUFSIZE%
echo VideoResolution=%VideoResolution%
 
rem ================== Stop any process ==========================
taskkill  /IM ffmpeg.exe
taskkill  /IM plink.exe

rem ======================== Launch ffmpeg VMIX =========================

if %vmix% == 1 (
echo launch ffmpeg VMIX
if %audioenable% == 1 (

if %Codec% == x264 (
start "Vmix to udp/ts" /HIGH ^
C:\ffmpeg\bin\ffmpeg ^
-rtbufsize 1500M ^
-f dshow -i video="vMix Video" -f dshow -i audio="vMix Audio" ^
-vf "drawtext=fontfile='C\:\\Windows\\Fonts\\verdanab.ttf':text='%callsign%':x=0:y=38:fontsize=80:fontcolor=0xffffff7f:shadowcolor=0x003f007f:shadowx=2:shadowy=2, drawtext=fontfile='C\:\\Windows\\Fonts\\verdanab.ttf':text='%TextConstellation%':x=0:y=12:fontsize=24:fontcolor=0xffffff9f:shadowcolor=0x00007f9f:shadowx=2:shadowy=2" ^
-c:v lib%Codec% -x264-params "nal-hrd=cbr:force-cfr=1::keyint=100" -preset fast -pix_fmt yuv420p -r %fps% -s %VideoResolution% -aspect %aspectratio% -qmin 2 -qmax 50 -g 100 ^
-b:v %VIDRATE% -minrate %VIDRATE% -maxrate %VIDRATE% -bufsize %BUFSIZE% -muxrate %TSBITRATE% ^
-c:a aac -b:a %audiobitrate% -ar 48000 -ac 1 ^
-f mpegts -mpegts_original_network_id 1 -mpegts_transport_stream_id 1 -mpegts_service_id 1 -mpegts_pmt_start_pid 4096 -streamid 0:256 -streamid 1:257 ^
-metadata service_provider="QO-100" -metadata service_name=%callsign% ^
-flush_packets 0 -f mpegts "udp://%ip%:10000?pkt_size=1316"
)

if %Codec% == x265 (
start "Vmix to udp/ts" /high ^
C:\ffmpeg\bin\ffmpeg ^
-rtbufsize 1500M ^
-f dshow -i video="vMix Video" -f dshow -i audio="vMix Audio" ^
-vf "drawtext=fontfile='C\:\\Windows\\Fonts\\verdanab.ttf':text='%callsign%':x=60:y=38:fontsize=80:fontcolor=0xffffff7f:shadowcolor=0x003f007f:shadowx=2:shadowy=2, drawtext=fontfile='C\:\\Windows\\Fonts\\verdanab.ttf':text='%TextConstellation%':x=60:y=12:fontsize=24:fontcolor=0xffffff9f:shadowcolor=0x00007f9f:shadowx=2:shadowy=2" ^
-c:v lib%Codec% -x265-params "nal-hrd=cbr:force-cfr=1:keyint=100"  -preset superfast -pix_fmt yuv420p -r %fps% -s %VideoResolution% -aspect %aspectratio% -qmin 2 -qmax 50 ^
-b:v %VIDRATE% -minrate %VIDRATE% -maxrate %VIDRATE% -bufsize %BUFSIZE% -muxrate %TSBITRATE% ^
-c:a aac -b:a %audiobitrate% -ar 48000 -ac 1 ^
-f mpegts -mpegts_original_network_id 1 -mpegts_transport_stream_id 1 -mpegts_service_id 1 -mpegts_pmt_start_pid 4096 -streamid 0:256 -streamid 1:257 ^
-metadata service_provider="QO-100" -metadata service_name=%callsign% ^
-flush_packets 0 -f mpegts "udp://%ip%:10000?pkt_size=1316"
)

)
if %audioenable% == 0 (
if %Codec% == x264 (
start "Vmix to udp/ts" /high ^
C:\ffmpeg\bin\ffmpeg ^
-rtbufsize 1500M ^
-f dshow -i video="vMix Video" ^
-vf "drawtext=fontfile='C\:\\Windows\\Fonts\\verdanab.ttf':text='%callsign%':x=0:y=38:fontsize=80:fontcolor=0xffffff7f:shadowcolor=0x003f007f:shadowx=2:shadowy=2, drawtext=fontfile='C\:\\Windows\\Fonts\\verdanab.ttf':text='%TextConstellation%':x=0:y=12:fontsize=24:fontcolor=0xffffff9f:shadowcolor=0x00007f9f:shadowx=2:shadowy=2" ^
-c:v lib%Codec% -x264-params "nal-hrd=cbr:force-cfr=1::keyint=100" -preset fast -pix_fmt yuv420p -r %fps% -s %VideoResolution% -aspect %aspectratio% -qmin 2 -qmax 50 -g 100 ^
-b:v %VIDRATE% -minrate %VIDRATE% -maxrate %VIDRATE% -bufsize %BUFSIZE% -muxrate %TSBITRATE% ^
-f mpegts -mpegts_original_network_id 1 -mpegts_transport_stream_id 1 -mpegts_service_id 1 -mpegts_pmt_start_pid 4096 -streamid 0:256 ^
-metadata service_provider="QO-100" -metadata service_name=%callsign% ^
-flush_packets 0 -f mpegts "udp://%ip%:10000?pkt_size=1316"
)

if %Codec% == x265 (
start "Vmix to udp/ts" /high ^
C:\ffmpeg\bin\ffmpeg ^
-rtbufsize 1500M ^
-f dshow -i video="vMix Video" ^
-vf "drawtext=fontfile='C\:\\Windows\\Fonts\\verdanab.ttf':text='%callsign%':x=0:y=38:fontsize=80:fontcolor=0xffffff7f:shadowcolor=0x003f007f:shadowx=2:shadowy=2, drawtext=fontfile='C\:\\Windows\\Fonts\\verdanab.ttf':text='%TextConstellation%':x=0:y=12:fontsize=24:fontcolor=0xffffff9f:shadowcolor=0x00007f9f:shadowx=2:shadowy=2" ^
-c:v lib%Codec% -x265-params "nal-hrd=cbr:force-cfr=1:keyint=100"  -preset superfast -pix_fmt yuv420p -r %fps% -s %VideoResolution% -aspect %aspectratio% -qmin 2 -qmax 50 ^
-b:v %VIDRATE% -minrate %VIDRATE% -maxrate %VIDRATE% -bufsize %BUFSIZE% -muxrate %TSBITRATE% ^
-f mpegts -mpegts_original_network_id 1 -mpegts_transport_stream_id 1 -mpegts_service_id 1 -mpegts_pmt_start_pid 4096 -streamid 0:256  ^
-metadata service_provider="QO-100" -metadata service_name=%callsign% ^
-flush_packets 0 -f mpegts "udp://%ip%:10000?pkt_size=1316"
)
)
)


rem ======================== Launch ffmpeg OBS =========================
if %vmix% == 0 (
echo launch ffmpeg OBS
start "OBS to udp/ts" /high ^
C:\ffmpeg\bin\ffmpeg ^
-i udp://230.0.0.11:10000 -c:v copy -muxrate %TSBITRATE% -c:a copy ^
-mpegts_original_network_id 1 -mpegts_transport_stream_id 1 -mpegts_service_id 1 -mpegts_pmt_start_pid 4096 -streamid 0:256  ^
-metadata service_provider="QO-100" -metadata service_name=%callsign% ^
-flush_packets 0 -f mpegts "udp://%ip%:10000?pkt_size=1316"
)
rem ======================= COMMAND RPI ========================
if %rpi_command% == 1 (

set upsample=4
if /I %SR% GEQ 1000 (
set upsample=2
)

if /I %SR% GEQ 2000 (
set upsample=1
)

set upsample=1

echo modulator upsample %upsample%
 
echo launch ssh
start "SSH RPI" /high ^
/D "C:\Program Files\PuTTY\" "plink.exe" -batch -ssh -pw %passwd% %user%@%raspi_ip% "(sudo killall -9 dvb2iq ; sudo killall -9 limesdr_send; nc -u -l -p 10000 | %dvb2iqpath% -s %SR% -f %FECNUM%/%FECDEN% -r %upsample% -m %MODE% -c %CONSTEL% -p | sudo %sendiqpath% -f %qrg% -b 2.5e6 -s %SR%000 -g %gainrf% -p 0.05 -a BAND1 -r %upsample% -l 102400 -q 1)"
rem "C:\Program Files\PuTTY\plink.exe" -batch -ssh -pw %passwd% %user%@%raspi_ip% "(sudo killall -9 dvb2iq ; sudo killall -9 limesdr_send; nc -u -l -p 10000 | %dvb2iqpath% -s %SR% -f %FECNUM%/%FECDEN% -r %upsample% -m %MODE% -c %CONSTEL% -p | sudo %sendiqpath% -f %qrg% -b 2.5e6 -s %SR%000 -g %gainrf% -p 0.05 -a BAND1 -r %upsample% -l 102400 -q 1)"
)

GOTO :PromptMe

:Quit

taskkill  /IM ffmpeg.exe
taskkill  /IM plink.exe